javax.ws.rs

## Annotation Type MatrixParam

-     @Target(value={PARAMETER,METHOD,FIELD})
      @Retention(value=RUNTIME)
      @Documented
      public @interface MatrixParam

  Binds the value(s) of a URI matrix parameter to a resource method parameter, resource class field, or resource class bean property. Values are URL decoded unless this is disabled using the `Encoded` annotation. A default value can be specified using the `DefaultValue` annotation.

  Note that the `@MatrixParam` `annotation value` refers to a name of a matrix parameter that resides in the last matched path segment of the `Path`-annotated Java structure that injects the value of the matrix parameter.

  The type `T` of the annotated parameter, field or property must either:

  1. Be a primitive type
  2. Have a constructor that accepts a single `String` argument
  3. Have a static method named `valueOf` or `fromString` that accepts a single `String` argument (see, for example, `Integer.valueOf(String)`)
  4. Have a registered implementation of `ParamConverterProvider` JAX-RS extension SPI that returns a `ParamConverter` instance capable of a "from string" conversion for the type.
  5. Be `List<T>`, `Set<T>` or `SortedSet<T>`, where `T` satisfies 2, 3 or 4 above. The resulting collection is read-only.

  If the type is not one of the collection types listed in 5 above and the matrix parameter is represented by multiple values then the first value (lexically) of the parameter is used.

  Because injection occurs at object creation time, use of this annotation on resource class fields and bean properties is only supported for the default per-request resource class lifecycle. Resource classes using other lifecycles should only use this annotation on resource method parameters.

  Since:
    1.0
  Author:
    Paul Sandoz, Marc Hadley
  See Also:
    `DefaultValue`, `Encoded`, Matrix URIs

- - ### Required Element Summary

    Required Elements
    Modifier and Type | Required Element and Description
    --- | ---
    `String` | `value` Defines the name of the URI matrix parameter whose value will be used to initialize the value of the annotated method argument, class field or bean property.

- - ### Element Detail

    - #### value

          public abstract String value

      Defines the name of the URI matrix parameter whose value will be used to initialize the value of the annotated method argument, class field or bean property. The name is specified in decoded form, any percent encoded literals within the value will not be decoded and will instead be treated as literal text. E.g. if the parameter name is "a b" then the value of the annotation is "a b", not "a+b" or "a%20b".

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.